VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Dim mvar_totalLines As Long
Dim m_lines() As CLine          ' The actual lines
Public m_curLines As Long          ' Current number of lines we're USING
Public m_curLine As Long           ' Current line we're on

Public Property Get m_totalLines() As Long
    m_totalLines = mvar_totalLines
End Property

Public Property Let m_totalLines(newValue As Long)
    Dim I As Long
    mvar_totalLines = newValue
    ReDim Preserve m_lines(0 To mvar_totalLines) As CLine
    For I = 0 To mvar_totalLines
        If m_lines(I) Is Nothing Then Set m_lines(I) = New CLine
    Next
End Property

Public Sub Pop(ByVal num As Long)
    If num < 0 Then Exit Sub
    If num > m_curLines Then Exit Sub
    
    m_curLines = m_curLines - num
    If m_curLines < 0 Then m_curLines = 0
    Dim I As Long
    For I = 0 To num
        m_lines(I).Clear
    Next
End Sub

Sub SetData(ByVal num As Long, ByVal data As String)
    If num < 0 Then Exit Sub
    If num > m_curLines Then Exit Sub
    
    m_curLines = m_curLines + 1
    If m_curLines > m_totalLines Then m_curLines = m_totalLines
    m_lines(num).SetData data
End Sub

Public Function GetData(ByVal num As Long) As String
    If num < 0 Then Exit Function
    If num > m_curLines Then Exit Function
    GetData = m_lines(num).m_data
End Function

Public Sub Append(ByVal data As String)
    Dim I As Long
    If m_curLines + 1 > m_totalLines Then
        For I = 0 To m_curLines - 1
            m_lines(I).SetData m_lines(I + 1).m_data
        Next
        m_curLines = m_curLines + 1
        m_lines(I).SetData data
        If m_curLines > m_totalLines Then m_curLines = m_totalLines
    Else
        m_curLines = m_curLines + 1
        m_lines(m_curLines).SetData data
    End If
End Sub

Private Sub Class_Initialize()
    m_totalLines = (m_WinRect.Bottom - m_WinRect.Top) / 18
    m_curLines = -1
End Sub

Private Sub Class_Terminate()
    Dim I  As Long
    For I = 0 To m_totalLines
        Set m_lines(I) = Nothing
    Next
End Sub
