Attribute VB_Name = "WinAPI"
Option Explicit

' Screen Capture Variables
Public Type PicBmp
    Size As Long
    Type As Long
    hBmp As Long
    hPal As Long
    Reserved As Long
End Type

Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long

Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
    ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, _
    ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
    ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
    
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Public Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, _
                ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long

Private Const WM_MOVE = &H3
Private Const WM_RESIZE = &H5
Private Const WM_KEYDOWN = &H100
Private Const WM_KEYUP = &H101

Private Declare Function CallWindowProc& Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long)

Public Function WindowProc(ByVal hWnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    On Error GoTo errs
    
    If (MSG = WM_MOVE Or MSG = WM_RESIZE) And (Not fScreen And ResizeOK) Then ReInit
    
    If MSG = WM_KEYDOWN Then
        If wParam = 192 Then
            GUIelements.GetElement("CONSOLE").ToggleActive
        ElseIf GUIelements.GetElement("CONSOLE").Active Then
            GUIelements.GetElement("CONSOLE").ProcessKeyInput wParam
        Else
            Keys(wParam) = True
        End If
    End If
    If MSG = WM_KEYUP Then Keys(wParam) = False
errs:
    WindowProc = CallWindowProc(PrevWndProc, hWnd, MSG, wParam, lParam)
End Function

'=================================
' Extra Vector Functions
'=================================
Public Function MakeVector(x As Single, y As Single, z As Single) As D3DVECTOR
    MakeVector.x = x
    MakeVector.y = y
    MakeVector.z = z
End Function

Public Function Translate(x As Single, y As Single, z As Single) As D3DMATRIX
    DX7.IdentityMatrix Translate
    Translate.rc41 = x
    Translate.rc42 = y
    Translate.rc43 = z
End Function
